# ----------------------------------------------
# - Section: Lookup Fields
# ----------------------------------------------

module PlutoraRest
  class Calls

  	#--------------------------
  	#-------- GET CALL --------
  	#--------------------------

  	#---- Get Lookupfields by Type ----
  	def get_lookupfields_byType(opts = {})
  		if opts[:type] == nil
  			raise "Get Lookup Fields, Type value is required!"
  		end

  		url = "#{@base_url}lookupfields/#{opts[:type]}"

  		headers = {'Authorization' => 'Bearer ' + (opts[:token] == nil ? @token : opts[:token])}

  		resp=formatResp({:xml => plutora_get({:url => url, :headers => headers})})
  		return resp
  	end

  	#-----------------------------
  	#---------- Helpers ----------
  	#-----------------------------

  	#---- Return Lookup Field Id by Type ----
  	def get_LookupField_ValueID(opts = {})
  		if opts[:type] == nil
  			raise "Get Lookup Field Value Id requires a Type value."
  		end
  		if opts[:value] == nil
  			raise "Get Lookup Field Value Id requires a Value to lookup."
  		end

  		sId = ''

  		if opts[:data].class == Hash
			if opts[:data]['Type'] == opts[:type]
				if opts[:data]['Value'] == opts[:value]
					sID = opts[:data]['Id']
				end
			end
		else
			opts[:data].each do |fields|
				if fields['Type'] == opts[:type]
					if fields['Value'] == opts[:value]
						sID = fields['Id']
					end
				end
			end
		end

		return (sID == '' ? false : sID)
  	end

  end
end