# ----------------------------------------------
# - Section: Releases
# ----------------------------------------------

module PlutoraRest
  class Calls
  	
  	#--------------------------
  	#-------- GET CALL --------
  	#--------------------------

  	#---- Get Releases ----
  	def get_Releases(opts = {})
  		token=opts[:token] || @token

  		url = "#{@base_url}releases"

  		headers = {'Authorization' => 'Bearer ' + token}

  		resp=plutora_get({:url => url, :headers => headers})
  		resp=formatResp({:xml => resp})
  		return resp
  	end

  	#---- Get Releases By Id ----
  	def get_ReleasesById(opts = {})
  		if opts[:id] == nil
  			raise "Releases By Id requires an ID value!"
  		end

  		url = "#{@base_url}releases/#{opts[:id]}"

  		headers = {'Authorization' => 'Bearer ' + (opts[:token] == nil ? @token : opts[:token])}

  		resp=formatResp({:xml => plutora_get({:url => url, :headers => headers})})
  		return resp
  	end

    #---- Get Releases By Id Additional Information ----
    def get_ReleasesById_AdditionalInformation(opts = {})
      if opts[:id] == nil
        raise "Release By Id Additional Information requires an ID value!"
      end

      url "#{@base_url}releases/#{opts[:id]}/additionalInformation"

      headers = {'Authorization' => 'Bearer ' + (opts[:token] == nil ? @token : opts[:token])}

      resp=formatResp({:xml => plutora_get({:url => url, :headers => headers})})
      return resp
    end

    #---- Get Release By Id Systems ----
    def get_ReleaseById_Systems(opts = {})
      if opts[:id] == nil
        raise "Release By Id Systems requires an ID value!"
      end

      url "#{@base_url}releases/#{opts[:id]}/system"

      headers = {'Authorization' => 'Bearer ' + (opts[:token] == nil ? @token : opts[:token])}

      resp=formatResp({:xml => plutora_get({:url => url, :headers => headers})})
      return resp
    end

    #--------------------------
    #-------- PUT CALL --------
    #--------------------------

    #---- Put Releases By Id ----
    def update_ReleasesById(opts = {})
      if opts[:id] == nil
        raise "Update Releases By Id requires an ID value!"
      end
      if opts[:params] == nil
        raise "Update Releasee By Id requires Parameters!"
      end

      url = "#{@base_url}releases/#{opts[:id]}"

      headers = {
        'Authorization' => "Bearer #{(opts[:token] == nil ? @token : opts[:token])}", 
        'Accept' => 'application/json', 
        'Content-Type' => 'application/x-www-form-urlencoded'
        #'Content-Type' => 'application/json'
      }

      resp=plutora_put({:url => url, :params => opts[:params], :headers => headers})
      return (resp.code == 204 ? true : false)
    end

    #---- Put Releases By Id Additional Information ----
    def update_ReleasesById_AdditionalInformation(opts = {})
      if opts[:id] == nil
        raise "Update Releases By Id requires an ID value!"
      end
      if opts[:params] == nil
        raise "Update Releasee By Id requires Parameters!"
      end

      url = "#{@base_url}releases/#{opts[:id]}/additionalInformation"

      headers = {
        'Authorization' => "Bearer #{(opts[:token] == nil ? @token : opts[:token])}", 
        'Accept' => 'application/json', 
        'Content-Type' => 'application/x-www-form-urlencoded'
        #'Content-Type' => 'application/json'
      }

      resp=plutora_put({:url => url, :params => opts[:params], :headers => headers})
      return (resp.code == 204 ? true : false)
    end

  end
end