# ----------------------------------------------
# - Section: Releases
# ----------------------------------------------

module PlutoraRest
  class Calls
  	
  	#--------------------------
  	#-------- GET CALL --------
  	#--------------------------

  	#---- Get Releases ----
  	def get_Systems(opts = {})
  		vRetry=0
      begin
        token=opts[:token] || @token

    		url = "#{@base_url}systems"

    		headers = {'Authorization' => 'Bearer ' + token}

    		resp=plutora_get({:url => url, :headers => headers})
    		resp=formatResp({:xml => resp})
    		return resp
      rescue
        puts "-----> Get Systems Error <-----"
        puts $!
        puts $@
        puts "<----------------------------->"
        if $! == "500 Internal Server Error"
          vRetry+=1
          retry if vRetry < 2
        end
      end
  	end

  	#---- Get Releases By Id ----
  	def get_SystemsById(opts = {})
  		if opts[:id] == nil
  			raise "Systems By Id requires an ID value!"
  		end

  		url = "#{@base_url}systems/#{opts[:id]}"

  		headers = {'Authorization' => 'Bearer ' + (opts[:token] == nil ? @token : opts[:token])}

  		resp=formatResp({:xml => plutora_get({:url => url, :headers => headers})})
  		return resp
  	end

  end
end